<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="企业" prop="beyondEnterpriseId">
        <el-select v-model="queryParams.beyondEnterpriseId" placeholder="请选择所属企业" clearable size="small">
          <el-option
            v-for = "dict in enterpriseList"
            :key = "dict.enterpriseId"
            :label = "dict.enterpriseName"
            :value = "dict.enterpriseId"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="违法标题" prop="illegalTitle">
        <el-input
          v-model="queryParams.illegalTitle"
          placeholder="请输入违法标题"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['gasBottleTrack:illegal:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['gasBottleTrack:illegal:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['gasBottleTrack:illegal:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
		  :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['gasBottleTrack:illegal:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="illegalList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="企业" align="center" prop="enterpriseName" />
      <el-table-column label="违法标题" align="center" prop="illegalTitle" />
      <el-table-column label="违法内容" align="center" prop="content" />
      <el-table-column label="违法人员" align="center" prop="people" />
      <el-table-column label="违法时间" align="center" prop="illegalTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.illegalTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="处罚结果" align="center" prop="penalty" />
      <el-table-column label="档案附件" align="center" prop="fileUrl" >
        <template slot-scope="scope">
          <span
            class="dbtn"
            @click="checkFile(scope.row.fileUrl)"
            v-if="scope.row.fileUrl != null && scope.row.fileUrl!=''"
          >
            <i class="el-icon el-icon-view"></i>查看/下载
          </span>
          <span v-else>-</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['gasBottleTrack:illegal:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['gasBottleTrack:illegal:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改违法行为档案对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="600px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="企业" prop="beyondEnterpriseId">
          <el-select v-model="form.beyondEnterpriseId" placeholder="请选择所属企业" clearable size="small">
            <el-option
              v-for = "dict in enterpriseList"
              :key = "dict.enterpriseId"
              :label = "dict.enterpriseName"
              :value = "dict.enterpriseId"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="违法标题" prop="illegalTitle">
          <el-input v-model="form.illegalTitle" placeholder="请输入违法标题" />
        </el-form-item>
        <el-form-item label="违法内容" prop="content">
          <el-input v-model="form.content" type="textarea" placeholder="请输入内容" />
        </el-form-item>
        <el-form-item label="违法人员" prop="people">
          <el-input v-model="form.people" placeholder="请输入违法人员" />
        </el-form-item>
        <el-form-item label="违法时间" prop="illegalTime">
          <el-date-picker clearable size="small"
            v-model="form.illegalTime"
            type="date"
            value-format="yyyy-MM-dd"
            placeholder="选择违法时间">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="处罚结果" prop="penalty">
          <el-input v-model="form.penalty" type="textarea" placeholder="请输入内容" />
        </el-form-item>
        <el-form-item label="档案附件" prop="fileUrl">
          <FileUpload
            listType="picture"
            @resFun="getFileInfo"
            @remove="listRemove"
            :fileArr="fileList"
          />
          <el-input v-show="false" disabled v-model="form.fileUrl"></el-input>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listIllegal, getIllegal, delIllegal, addIllegal, updateIllegal, exportIllegal } from "@/api/gasBottleTrack/illegal";
import {enterpriseList } from "@/api/system/planInfo";
import FileUpload from '@/components/FileUpload';
let uploadfile = require("@/assets/uploadfile.png");
export default {
  name: "Illegal",
  components: {
    FileUpload
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 违法行为档案表格数据
      illegalList: [],
      enterpriseList:[],
      fileList:[],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        beyondEnterpriseId: null,
        illegalTitle: null,
        illegalTime: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        beyondEnterpriseId: [
          { required: true, message: "请选择企业", trigger: "blur" },
        ],
        illegalTitle: [
          { required: true, message: "请输入违法标题", trigger: "blur" },
        ],
        content: [
          { required: true, message: "请输入违法内容 ", trigger: "blur" },
        ],
      }
    };
  },
  created() {
    this.getList();
    this.getEnterpriseList()
  },
  methods: {
    //公司列表
    getEnterpriseList() {
      enterpriseList({pageNum: 1,
        pageSize: 100}).then(response => {
        this.enterpriseList = response.data;
    });
    },
    /** 查询违法行为档案列表 */
    getList() {
      this.loading = true;
      listIllegal(this.queryParams).then(response => {
        this.illegalList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },

    //上传
    getFileInfo(res){
      //this.form.dealPlan = res.fileName;
      this.form.fileUrl = res.url;
      this.fileList.push({
        name: res.fileName,
        url: uploadfile,
      });
    },
    listRemove(e) {
      this.form.fileUrl = "";
      this.fileList = [];
    },
    checkFile(url) {
      window.open(url,'_blank');
    },
    // 取消按钮
    cancel() {
      this.fileList = [];
      this.open = false;
      this.reset();
    },
    //点击下载
    downloadFile() {
      var item = this.fileurl;
      var title = item.split("/")[item.split("/").length-1];
      this.download(item,title);
    },
    download (src, fileName) {
      let x = new XMLHttpRequest();
      x.open("GET", src, true);
      x.responseType = 'blob';
      x.onload = function(e) {
        let url = window.URL.createObjectURL(x.response)
        let a = document.createElement('a');
        a.href = url
        a.download = fileName
        a.click()
      }
      x.send();
    },
    // 表单重置
    reset() {
      this.form = {
        illegalId: null,
        beyondEnterpriseId: null,
        illegalTitle: null,
        content: null,
        people: null,
        illegalTime: null,
        penalty: null,
        fileUrl: null,
        createTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.illegalId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加违法行为档案";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const illegalId = row.illegalId || this.ids
      getIllegal(illegalId).then(response => {
        this.form = response.data;
      if(this.form.fileUrl!=null||this.form.fileUrl==""){
        this.fileList = [{name: 'file', url:uploadfile}];
      }
        this.open = true;
        this.title = "修改违法行为档案";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.illegalId != null) {
            updateIllegal(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addIllegal(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const illegalIds = row.illegalId || this.ids;
      this.$confirm('是否确认删除违法行为档案编号为"' + illegalIds + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delIllegal(illegalIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有违法行为档案数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportIllegal(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
<style lang="scss" scoped>
  .dbtn {
    display: inline-block;
    line-height: normal;
    padding-left: 2px;
    padding-right: 2px;
    cursor: pointer;
    border-radius: 3px;
    border-style: solid;
    border-width: 0;
    color: rgb(48, 180, 107);
  }
  ::v-deep .el-select{
    width: 100%;
  }
</style>
